; The Terminal! v1.00
; Written by: Ahmed Mohamed Reda
; Requirements:
;       Two Computers linked through a serial cable plugged into COM2
; Notes: 
;       This program comes after delivering a project written in Visual Basic
; The size for that project was 17MB ! , so I think it is time to do some
; low level programming to balance the process! :)
;       In this program you may find Labels starting with the word 'Path'
; ,these labels are just jumps to the label next to the word path, it is done
; this way because of the +-128 bytes of the conditional jumps ..

; [Comm. Ports]
COM1 EQU 3f8h
COM2 EQU 2f8h
COM3 EQU 3e8h
COM4 EQU 2e8h
    
; [Colours]
BLACK   EQU 0
BLUE    EQU 1
GREEN   EQU 2
CYAN    EQU 3
RED     EQU 4
MAGENTA EQU 5
BROWN   EQU 6
GRAY    EQU 7
    


ACKNOWLEDGE EQU 255
FILEDATAPACKETLENGTH EQU 20
CHARACTERATTRIBUTE      EQU 1Fh

; [Packets]
CHARPACKET              EQU 0
FILEINITIATIONPACKET    EQU 1
FILEDATAPACKET          EQU 2
FILEENDPACKET           EQU 3
ESCPACKET               EQU 4
STARTOFCONNECTIONPACKET EQU 5
DUMMYPACKET             EQU 6


; [Errors]
INCORRECTACKNOWLEDGEBYTE EQU 0
UNKNOWNPACKET            EQU 1
FILEEND                  EQU 2

; [Keys]
RETURN          EQU 13
ESCAPE          EQU 27
BACKSPACE       EQU 8

; [Registers]
RDR      EQU 0
THR      EQU 0
BRDL     EQU 0
IER      EQU 1
BRDH     EQU 1
IIR      EQU 2
LCR      EQU 3
MCR      EQU 4
LSR      EQU 5
MSR      EQU 6

CODE SEGMENT
         ASSUME CS:CODE

         CursorXMaster       db 1
         CursorXSlave        db 1
         CursorYMaster       db 3
         CursorYSlave        db 15


         ErrorCode         db ?
         ErrorMessage      db "Error: ",'$'
         
         ReceiveFileName   db 15 dup (?)
         SendFileName      db "dpmires.exe",0,'$'

         ReceiveFileHandle dw ?
         SendFileHandle    dw ?

         EOFFlag                db 0                 ; send file completed
         FileBeingTransfered    db 0                 ; a file is being sent?   
         ConnectionStartedFlag  db 0

         SendingMessage         db "Sending: ",'$'
         ClearingMessage        db 27 dup (32),'$'
         SendBuffer             db 255 dup (?)
         ReceiveBuffer          db 255 dup (?)
         SendNameBuffer         db 25 dup (?)
         ReceiveNameBuffer      db 25 dup (?)
         
         ScreenBuffer           db 80*4*2 dup (?)

         FileNameMessage        db "FileName:         ",'$'
         WaitMessage1           db "Please",'$'
         WaitMessage2           db "      Wait",'$'
         ExittingMessage        db "   Exitting ...",'$'
         DisconnectedMessage    db " Disconnected ..",'$'
         YourNameMessage        db "Enter your name: ",'$'
         OptionMessage1         db "(1) Wait for call",'$'
         OptionMessage2         db "(2) Establish serial connection",'$'
         EnterChoiceMessage     db "Enter your Choice ..",'$'

        
BackupMidScreen PROC
        push es
        push di
        push ds
        push si
        push cx
        mov si,0b800h
        mov ds,si
        mov si,11*80*2
        mov di,Seg ScreenBuffer
        mov es,di
        mov di,offset ScreenBuffer
        mov cx,4*80*2
        rep movsb
        pop cx
        pop si
        pop ds
        pop di
        pop es
        ret
BackupMidScreen ENDP

RestoreMidScreen PROC
        push es
        push di
        push ds
        push si
        push cx
        mov di,0b800h
        mov es,di
        mov di,11*80*2
        mov si,Seg ScreenBuffer
        mov ds,si
        mov si,offset ScreenBuffer
        mov cx,4*80*2
        rep movsb
        pop cx
        pop si
        pop ds
        pop di
        pop es
        ret
RestoreMidScreen ENDP




DisplayFrame PROC
        push di
        push es
        push cx
        mov di,0b800h
        mov es,di
        mov di,11*2*80+30*2
        mov byte ptr es:[di],201                ;   
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        inc di
        mov cx,18
loop6:
        mov byte ptr es:[di],205                ; 
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        inc di
        loop loop6
        mov byte ptr es:[di],187
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        inc di
        mov di,12*2*80+30*2
        mov byte ptr es:[di],186                  ; 
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        mov cx,18
loop8:
        inc di
        mov byte ptr es:[di],' '
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        loop loop8
        inc di

        ;add di,20*2-1-2
        mov byte ptr es:[di],186                  ; 
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        
        mov di,13*2*80+30*2
        mov byte ptr es:[di],186                  ; 
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        mov cx,18
loop7:
        inc di
        mov byte ptr es:[di],' '
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        loop loop7
        inc di
        ;add di,20*2-1-2
        mov byte ptr es:[di],186                  ; 
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE

        mov di,14*2*80+30*2
        mov byte ptr es:[di],200                ; 
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        add di,20*2-1-2
        mov byte ptr es:[di],188                ; 
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        pop cx
        pop es
        pop di
        ret
DisplayFrame ENDP


         StringIndex       dw 0
         TempOffset        dw ?
         GetFileNameX      db ?
         GetFileNameY      db ?
         MaxNumber         dw ?
         MinChar           db ?
GetFileName PROC
        mov [StringIndex],0
         mov [TempOffset],si
GetFileNameLoop:
         mov ah,0
         int 16h
        cmp al,126
        ja GetFileNameLoop
        mov bl,[MinChar]

        cmp al,bl
        jb GetFileNameCheckKeys
        mov bx,[MaxNumber]
        cmp [StringIndex],bx
        je GetFileNameLoop

        mov si,[TempOffset]
        add si,[StringIndex]

        mov ds:[si],al
        inc [StringIndex]
        inc si
        mov byte ptr ds:[si],0
        inc si
        mov byte ptr ds:[si],'$'

         mov ah,2
         mov bh,0
         mov dh,[GetFileNameY]
         mov dl,[GetFileNameX]
         mov bx,[StringIndex]
         Add dl,bl
         int 10h
         mov ah,9
         mov bh,0
         mov bl,CHARACTERATTRIBUTE
         mov cx,1
         int 10h
         mov ah,2
         mov bh,0
         mov dh,[GetFileNameY]
         mov dl,[GetFileNameX]
         mov bx,[StringIndex]
         Add dl,bl
         inc dl
         int 10h

        jmp GetFileNameLoop

GetFileNameCheckKeys:
         cmp AL,RETURN
         je GetFileNameExit
         cmp al,BACKSPACE
         jne GetFileNameLoop
;BackSpace:
         cmp [StringIndex],0
         je PathGetFileNameLoop
         mov ah,2
         mov bh,0
         mov dh,[GetFileNameY]
         mov dl,[GetFileNameX]
         mov bx,[StringIndex]
         Add dl,bl
         int 10h
         mov ah,9
         mov al,' '
         mov bh,0
         mov bl,CHARACTERATTRIBUTE
         mov cx,1
         int 10h
         dec [StringIndex]
PathGetFileNameLoop:
         jmp GetFileNameLoop

GetFileNameExit:
         ret
GetFileName ENDP

WaitUntilTHRFree PROC
         push dx
         push ax
         mov dx,com2+LSR
WaitTillTHRFreeLoop:
         in al,dx
         and al,00100000B
         jz WaitTillTHRFreeLoop
         pop ax
         pop dx
         ret
WaitUntilTHRFree ENDP

SendAcknowledge PROC
         call WaitUntilTHRFree
         push dx
         push ax
         mov dx,com2+THR
         mov al,ACKNOWLEDGE
         out dx,al
         pop ax
         pop dx
         RET
SendAcknowledge ENDP

WaitAcknowledge PROC
         call WaitForByte
         push dx
         push ax
         mov dx,com2+RDR
         in al,dx
         cmp al,ACKNOWLEDGE
         jnz ErrorInAcknowledge
         pop ax
         pop dx
         ret
ErrorInAcknowledge:
         mov ErrorCode,INCORRECTACKNOWLEDGEBYTE
         call DisplayErrorMessage
         pop ax
         pop dx
         ret
WaitAcknowledge ENDP

DisplayErrorMessage PROC
         push ax
         push ds
         push dx
         push si
         mov ah,9
         mov dx,seg ErrorMessage
         mov ds,dx
         mov dx,offset ErrorMessage
         mov si,dx
         add si,6
         mov al,[ErrorCode]
         add al,'0'
         mov ds:[si],al
         int 21h
         pop si
         pop dx
         pop ds
         pop ax
         ret
DisplayErrorMessage ENDP

; inputs  ah=Keyboard Scan Code, al=ASCII code 
;         bx,cx -> (x,y)
        CurrentX db ?
        CurrentY db ?
        Char     db ?
AdjustViewPort PROC
        push ax
        push bx
        push cx
        push dx
        push ds
        push si
        push es
        push di

        mov [CurrentX],bl
        mov [CurrentY],cl
        mov [Char],al
        cmp al,126
        ja PathToAdjustExit
        cmp al,32
        jb CheckKeys
        cmp [CurrentX],78
        je NextLine

        mov ah,2
        mov bh,0
        mov dh,[CurrentY]
        mov dl,[CurrentX]
        int 10h
        inc [CurrentX]
        
        mov ah,9
        mov al,[Char]                   ; suspected to be of no meaning! (chk)
        mov bh,0
        mov bl,CHARACTERATTRIBUTE
        mov cx,1
        int 10h                         ; Display the character
PathToAdjustExit:
        jmp AdjustExit

NextLine:
        mov bl,[CurrentX]
        mov cl,[CurrentY]
        push ax
        mov al,RETURN
        call AdjustViewPort
        pop ax
        mov bl,[CurrentX]
        mov cl,[CurrentY]
        call AdjustViewPort
        
        jmp AdjustExit
CheckKeys:
        cmp al,RETURN
        je ReturnKey
        cmp al,ESCAPE
        
        cmp al,BACKSPACE
        je BackSpaceKey

ReturnKey:
        mov [CurrentX],1
        cmp [Currenty],13
        jb UpperReturn
        cmp [Currenty],13
        ja LowerReturn
UpperReturn:
        cmp [CurrentY],11
        je ScrollUpperWindow
        inc [CurrentY]
        jmp EndReturn
ScrollUpperWindow:
        mov ah,6                ; Scroll Window Up         
        mov al,1                ; no of lines to scroll
        mov bh,CHARACTERATTRIBUTE  ; attribute
        mov ch,3                ; Y (Row)
        mov cl,1                ; X (Column)
        mov dh,11
        mov dl,78
        int 10h
        jmp EndReturn
LowerReturn:
        cmp [CurrentY],23
        je ScrollLowerWindow
        inc [CurrentY]
        jmp EndReturn
ScrollLowerWindow:
        mov ah,6                ; Scroll Window Up         
        mov al,1                ; no of lines to scroll
        mov bh,CHARACTERATTRIBUTE              ; attribute
        mov ch,15               ; Y (Row) UpperLeft
        mov cl,1                ; X (Column) UpperLeft
        mov dh,23               ; Y (Row) DownRight
        mov dl,78               ; X (Column) DownRight
        int 10h
EndReturn:
        jmp AdjustExit

BackSpaceKey:
        cmp [CurrentX],1
        je EndBackSpace
        dec [CurrentX]
        mov ah,2
        mov bh,0
        mov dh,[CurrentY]
        mov dl,[CurrentX]
        int 10h
        
        mov ah,9
        mov al,' '
        mov bh,0
        mov bl,CHARACTERATTRIBUTE
        mov cx,1
        int 10h                         ; Display the character

EndBackSpace:
        jmp AdjustExit

AdjustExit:
        mov ah,2
        mov bh,0
        mov dh,[CurrentY]
        mov dl,[CurrentX]
        int 10h

        pop di
        pop es
        pop si
        pop ds
        pop dx
        pop cx
        pop bx
        pop ax
        ret
AdjustViewPort ENDP



WaitForByte PROC
         push dx
         push ax
         mov dx,com2+LSR
WaitForByteLoop:
         in al,dx
         and al,1
         jz WaitForByteLoop
         pop ax
         pop dx
         ret
WaitForByte ENDP

HorizontalLine1 PROC
        mov byte ptr es:[di],186                  ; 
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        add di,79*2-1
        mov byte ptr es:[di],186                  ; 
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        inc di
        ret
HorizontalLine1 ENDP

HorizontalLine2 PROC
        mov byte ptr es:[di],204                ; 
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        inc di
        mov cx,78
loop2:
        mov byte ptr es:[di],205                ; 
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        inc di
        loop loop2
        mov byte ptr es:[di],185
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        inc di
        ret
HorizontalLine2 ENDP

HorizontalLine3 PROC
        mov byte ptr es:[di],201                ; 
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        inc di
        mov cx,78
loop1:
        mov byte ptr es:[di],205                ; 
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        inc di
        loop loop1
        mov byte ptr es:[di],187
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        inc di
        ret
HorizontalLine3 ENDP

HorizontalLine4 PROC
        mov byte ptr es:[di],200                ; 
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        inc di
        mov cx,78
loop4:
        mov byte ptr es:[di],205                ; 
        inc di                  
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        inc di
        loop loop4
        mov byte ptr es:[di],188                ; 
        inc di
        mov byte ptr es:[di],CHARACTERATTRIBUTE
        inc di
        ret
HorizontalLine4 ENDP

GetNextIndicator PROC
        cmp al,' '
        je Next1
        cmp al,'-'
        je Next2 
        cmp al,'\'
        je Next3 
        cmp al,'|'
        je Next4 
        cmp al,'/'
        je Next1
Next1: 
        mov al,'-'
        ret
Next2: 
        mov al,'\'
        ret
Next3: 
        mov al,'|'
        ret
Next4: 
        mov al,'/'
        ret

        mov al,'-'
        ret        

GetNextIndicator ENDP


SetVideoMode PROC
         mov ax,3
         int 10h                             ; set the video mode 0x3b

         mov di,0b800h
         mov es,di

        mov di,0
        call HorizontalLine3
        call HorizontalLine1
        call HorizontalLine2
        mov cx,9
loop3:
        call HorizontalLine1
        loop loop3

        call HorizontalLine2
        call HorizontalLine1
        call HorizontalLine2
        
        mov cx,9
loop5:
        call HorizontalLine1
        loop loop5

        call HorizontalLine4

        mov ah,6
        mov al,0
        mov bh,CHARACTERATTRIBUTE
        mov ch,3
        mov cl,1
        mov dh,11
        mov dl,78
        int 10h

        add ch,12
        add dh,12
        int 10h

        mov bh,4fh
        mov ch,1
        mov dh,1
        int 10h
        mov ch,13
        mov dh,13
        int 10h

        ;mov ah,2
        ;mov bh,0
        ;mov dh,1
        ;mov dl,1
        ;int 10h

        ;mov ah,9
        ;mov dx,seg message1
        ;mov ds,dx
        ;mov dx,offset message1
        ;int 21h

        ;mov ah,2
        ;mov bh,0
        ;mov dh,13
        ;mov dl,1
        ;int 10h
        ;
        ;mov ah,9
        ;mov dx,seg message2
        ;mov ds,dx
        ;mov dx,offset message2
        ;int 21h


        ret
SetVideoMode ENDP

InitializeCommPort PROC
         push dx
         push ax
         mov dx,com2+LCR                     ; initialize with the settings
         mov al,10000011B                    ; 8 bit character length,
         out dx,al                           ; 1 stop bit, no parity, no break
                                             ; Use offset 0,1 for BRD setting
                                             
         mov ax,18432/(16*48)                ; calculate the BRD
         mov dx,com2+BRDL
         out dx,al                           ; set the BRDL
         mov dx,com2+BRDH
         mov al,ah
         out dx,al                           ; set the BRDH

         mov dx,com2+LCR                     ; initialize for using the
         mov al,00000011B                    ; THR/RDR
         out dx,al

         mov dx,com2+MCR                     ; initialize for Loopback
         mov al,00000000b
                           
         out dx,al
         pop ax
         pop dx
         ret
InitializeCommPort ENDP

ReceiveCharPacket PROC
         push dx
         push ax
         push bx

         ;mov ah,2
         ;mov bh,0
         ;mov dh,12
         ;mov dl,[CursorXSlave]
         ;int 10h                             ; move Cursor to CursorXSlave,12
         ;inc [CursorXSlave]                  ; advance CursorXSlave
                  
         call WaitforByte
         mov dx,com2+RDR
         in al,dx                           ; get the received character
        
        mov bl,[CursorXSlave]
        Mov cl,[CursorYSlave]
        call AdjustViewPort
        mov bl,[CurrentX]
        mov cl,[CurrentY]
        mov [CursorXSlave],bl
        mov [CursorYSlave],cl


         ;mov ah,9
         ;mov bh,0
         ;mov bl,4fh
         ;;mov cx,1
         ;int 10h                             ; display it at the C.P.

         call SendAcknowledge                ; Send Acknowledge

         pop bx
         pop ax
         pop dx
         ret
ReceiveCharPacket ENDP

SendDummyPacket PROC
        push dx
        push ax
        call WaitUntilTHRFree
        mov dx,com2+THR
        mov al,DUMMYPACKET
        out dx,al

        pop ax
        pop dx
        ret
SendDummyPacket ENDP


ReceiveESCPacket PROC
         push dx
         push ax
         push bx
        call DisplayFrame

        mov ah,2
        mov bh,0
        mov dh,12
        mov dl,31
        int 10h

        mov ah,9
        mov dx,seg DisconnectedMessage
        mov ds,dx
        mov dx,offset DisconnectedMessage
        int 21h

        mov ah,2
        mov bh,0
        mov dh,24
        mov dl,31
        int 10h



         call SendAcknowledge                ; Send Acknowledge
         mov ax,4c00h
         int 21h
         pop bx
         pop ax
         pop dx
         ret
ReceiveESCPacket ENDP


SendESCPacket PROC
         mov dx,com2+THR                     ; 0 then the character 
         mov al,ESCPACKET                            ; ASCII code
        call WaitUntilTHRFree
        out dx,al
         
         call WaitAcknowledge
        call DisplayFrame

        mov ah,2
        mov bh,0
        mov dh,12
        mov dl,31
        int 10h

        mov ah,9
        mov dx,seg ExittingMessage
        mov ds,dx
        mov dx,offset ExittingMessage
        int 21h
        
        mov ah,2
        mov bh,0
        mov dh,24
        mov dl,31
        int 10h


         mov ax,4c00h
         int 21h
         ret
SendESCPacket ENDP



SendCharPacket PROC

         push ax                             ; Send a character frame
         mov dx,com2+THR                     ; 0 then the character 
         mov al,0                            ; ASCII code
         call WaitUntilTHRFree
         out dx,al
         pop ax
         call WaitUntilTHRFree
         out dx,al
         call WaitAcknowledge
         ret
SendCharPacket ENDP

ReceiveFileInitiationPacket PROC
        push cx
        push dx
        push si
        push ds

        call BackupMidScreen        

        call DisplayFrame

        mov ah,2
        mov bh,0
        mov dh,12
        mov dl,31
        int 10h

        mov ah,9
        mov dx,seg WaitMessage1
        mov ds,dx
        mov dx,offset WaitMessage1
        int 21h

        mov ah,2
        mov bh,0
        mov dh,13
        mov dl,31
        int 10h

        mov ah,9
        mov dx,seg WaitMessage2
        mov ds,dx
        mov dx,offset WaitMessage2
        int 21h

        mov cx,0

ReceiveFileNameLoop:                    ; receive 13 characters for the file 
        call WaitForByte                ; name
        mov dx,com2+RDR
        in al,dx
        mov si,Seg ReceiveFileName
        mov ds,si
        mov si,offset ReceiveFileName
        add si,cx
        mov ds:[si],al
        inc cx
        cmp cx,12                       
        jna ReceiveFileNameLoop

        mov ah,3ch                      ; Create a file with the name
        mov cx,0                        ; received
        mov dx,seg ReceiveFileName
        mov ds,dx
        mov dx,offset ReceiveFileName
        int 21h
        mov [ReceiveFileHandle],ax

        

        call RestoreMidScreen

        mov ah,2
        mov bh,0
        mov dh,13
        mov dl,50
        int 10h


        mov ah,9
        mov dx,seg SendingMessage
        mov ds,dx
        mov dx,offset SendingMessage
        int 21h


        mov dx,seg ReceiveFileName
        mov ds,dx
        mov dx,offset ReceiveFileName
        int 21h
      ;
      ;  
     ;   mov [ReceiveFileHandle],ax      ; keep its handle
        
        
        call SendAcknowledge

        pop ds
        pop si
        pop dx
        pop cx
        
        ret
ReceiveFileInitiationPacket ENDP

SendFileInitiationPacket PROC
        push cx
        push dx
        push si
        push ds
        push bx

        call WaitUntilTHRFree
        mov dx,com2+THR
        mov al,FILEINITIATIONPACKET
        out dx,al
        call BackupMidScreen        

        call DisplayFrame

        mov ah,2
        mov bh,0
        mov dh,12
        mov dl,31
        int 10h

        mov ah,9
        mov dx,seg FileNameMessage
        mov ds,dx
        mov dx,offset FileNameMessage
        int 21h

        mov GetFileNameX,31
        mov GetFileNameY,13
        mov MinChar,33
        mov MaxNumber,12
        mov si,seg SendFilename
        mov ds,si
        mov si,offset SendFilename
        call GetFileName

        call RestoreMidScreen

        mov ah,3dh                      ; open the send file for read
        mov al,0
        mov dx,seg SendFileName
        mov ds,dx
        mov dx,offset SendFileName
        int 21h

        mov [SendFileHandle],ax         ; keep its handle

        mov ah,2
        mov bh,0
        mov dh,1
        mov dl,50
        int 10h
        
        mov ah,9
        mov dx,seg SendingMessage
        mov ds,dx
        mov dx,offset SendingMessage
        int 21h

        mov dx,seg SendFileName
        mov ds,dx
        mov dx,offset SendFileName
        int 21h


        mov cx,0
SendFileNameLoop:                    ; send the 13 characters of the file 
        call WaitUntilTHRFree            ; name
        mov si,Seg SendFileName
        mov ds,si
        mov si,offset SendFileName
        add si,cx
        mov al,ds:[si]

        mov dx,com2+THR
        out dx,al

        inc cx
        cmp cx,12
        jna SendFileNameLoop

        call WaitAcknowledge            ; wait till the other side
                                        ; acknowledges that it received the
                                        ; file name and that it created it!
        pop bx
        pop ds
        pop si
        pop dx
        pop cx
        
        ret
SendFileInitiationPacket ENDP

ReceiveStartOfConnectionPacket PROC
        push cx
        push dx
        push si
        push ds


        mov cx,0

ReceiveUserNameLoop:                    ; receive 22 characters for the other
        call WaitForByte                ; user name
        mov dx,com2+RDR
        in al,dx
        mov si,Seg ReceiveNameBuffer
        mov ds,si
        mov si,offset ReceiveNameBuffer
        add si,cx
        mov ds:[si],al
        inc cx
        cmp cx,21
        jna ReceiveUserNameLoop

        mov ah,2
        mov bh,0
        mov dh,13
        mov dl,1
        int 10h

        mov ah,9
        mov dx,seg ReceiveNameBuffer
        mov ds,dx
        mov dx,offset ReceiveNameBuffer
        int 21h
        
        call SendAcknowledge

        pop ds
        pop si
        pop dx
        pop cx
        
        ret
ReceiveStartOfConnectionPacket ENDP



SendStartOfConnectionPacket PROC
        push cx
        push dx
        push si
        push ds
        push bx

        call WaitUntilTHRFree
        mov dx,com2+THR
        mov al,STARTOFCONNECTIONPACKET
        out dx,al
        

        mov cx,0
SendUserNameLoop:                    ; send the 13 characters of the file 
        call WaitUntilTHRFree            ; name
        mov si,Seg SendNameBuffer
        mov ds,si
        mov si,offset SendNameBuffer
        add si,cx
        mov al,ds:[si]
        
        mov dx,com2+THR
        out dx,al

        inc cx
        cmp cx,21
        jna SendUserNameLoop

        mov ah,2                        ; Set cursor position
        mov bh,0
        mov dh,1                        ; Y
        mov dl,1                        ; X
        int 10h
        
        mov ah,9
        mov dx,seg SendNameBuffer
        mov ds,dx
        mov dx,offset SendNameBuffer
        int 21h


        call WaitAcknowledge            ; wait till the other side
                                        ; acknowledges that it received the
                                        ; file name and that it created it!
        pop bx
        pop ds
        pop si
        pop dx
        pop cx
        
        ret
SendStartOfConnectionPacket ENDP




        NoOfBytesRead db ?              ; Local variable used with the
                                        ; next fn.
        NoOfBytesReadDecreased db ?

SendFileDataPacket PROC

        push ax
        push bx
        push cx
        push dx
        push ds
        push si
        push es
        push di
        
        call WaitUntilTHRFree
        mov dx,com2+THR
        mov al,FILEDATAPACKET
        out dx,al

        mov di,0b800h
        mov es,di
        mov di,152+80*2
        mov al,es:[di]
        call GetNextIndicator
        mov es:[di],al

        mov ah,3fh                      ; read a file data packet 
        mov bx,[SendFileHandle]
        mov cx,FILEDATAPACKETLENGTH
        mov dx,seg SendBuffer
        mov ds,dx
        mov dx,offset Sendbuffer
        int 21h
                                         ; ax now containing the no. of bytes
                                         ; read with restricting the file data
                                         ; packet range from 1 to 255 , only
                                         ; al can be used to indicate the
                                         ; no. of bytes read, so send it to
                                         ; the other side! , note that if
                                         ; "0 <= al < FILEDATAPACKETLENGTH"
                                         ; then EOF reached 

        call WaitUntilTHRFree            
        mov dx,com2+thr
        out dx,al

        cmp al,FILEDATAPACKETLENGTH
        je NotEOF
;EOF:
        mov [EOFFlag],1
NotEOF:
        mov [NoOfBytesRead],al
        mov [NoOfBytesReadDecreased],al
        dec [NoOfBytesReadDecreased]
        
        cmp [NoOfBytesRead],0
        je EndOfDataPacketTransfer
        
        xor cx,cx
SendFileDataPacketLoop:
        call WaitUntilTHRFree            
        mov si,Seg SendBuffer
        mov ds,si
        mov si,offset SendBuffer
        add si,cx
        mov al,ds:[si]
        mov dx,com2+THR
        out dx,al
        inc cx
        cmp cl,[NoOfBytesReadDecreased]
        jna SendFileDataPacketLoop
EndOfDataPacketTransfer:
        call WaitAcknowledge
        
        pop di
        pop es
        pop si
        pop ds
        pop dx
        pop cx
        pop bx
        pop ax

        ret
SendFileDataPacket ENDP




        NoOfBytesToReceive db ?              ; Local variable used with the
                                             ; next fn.
        NoOfBytesToReceiveDecreased db ?

ReceiveFileDataPacket PROC

        push ax
        push bx
        push cx
        push dx
        push ds
        push si

        call WaitforByte
        
        mov dx,com2+RDR
        in al,dx
        mov [NoOfBytesToReceive],al
        mov [NoOfBytesToReceiveDecreased],al
        dec [NoOfBytesToReceiveDecreased]

        cmp [NoOfBytesToReceive],0
        je FileDataPacketReceived

        mov cx,0
ReceiveFileDataPacketLoop:
        call WaitForByte
        mov dx,com2+RDR
        in al,dx
        mov si,Seg ReceiveBuffer
        mov ds,si
        mov si,offset ReceiveBuffer
        add si,cx
        mov ds:[si],al
        inc cx
        cmp cl,[NoOfBytesToReceiveDecreased]
        jna ReceiveFileDataPacketLoop

        mov ah,40h
        mov bx,[ReceiveFileHandle]
        mov cl,[NoOfBytesToReceive]
        mov dx,seg ReceiveBuffer
        mov ds,dx
        mov dx,offset ReceiveBuffer
        int 21h

FileDataPacketReceived:
        mov di,0b800h
        mov es,di
        mov di,152+80*2+1920
        mov al,es:[di]
        call GetNextIndicator
        mov es:[di],al



        call SendAcknowledge

        pop si
        pop ds
        pop dx
        pop cx
        pop bx
        pop ax

        ret
ReceiveFileDataPacket ENDP


ReceiveEndFilePacket PROC
        push ax
        push bx
        push dx
        push ds

       
        call WaitAcknowledge
        mov ah,3eh
        mov bx,[ReceiveFileHandle]
        int 21h
        call SendAcknowledge
        ;mov ErrorCode,FILEEND
        ;call DisplayErrorMessage

        mov ah,2
        mov bh,0
        mov dh,13
        mov dl,50
        int 10h
        
        mov ah,9
        mov dx,seg ClearingMessage
        mov ds,dx
        mov dx,offset ClearingMessage
        int 21h

        pop ds
        pop dx
        pop bx
        pop ax

        ret

ReceiveEndFilePacket ENDP

SendEndFilePacket PROC
        push ax
        push bx
        push dx
        push ds

        call WaitUntilTHRFree
        mov dx,com2+THR
        mov al,FILEENDPACKET
        out dx,al



        mov ah,3eh
        mov bx,[SendFileHandle]
        int 21h
        call SendAcknowledge

        call WaitAcknowledge
        mov [EOFFlag],0

        mov ah,2
        mov bh,0
        mov dh,1
        mov dl,50
        int 10h
        
        mov ah,9
        mov dx,seg ClearingMessage
        mov ds,dx
        mov dx,offset ClearingMessage
        int 21h

        pop ds        
        pop dx
        pop bx
        pop ax

        ret
SendEndFilePacket ENDP



Start:
         push cs
         pop ds
         
         mov ax,3
         int 10h                             ; set the video mode 0x3b

        mov ah,9        
        mov dx,seg YourNameMessage
        mov ds,dx
        mov dx,offset YourNameMessage
        int 21h

        mov GetFileNameX,18
        mov GetFileNameY,0
        mov MinChar,32
        mov MaxNumber,20
        mov si,seg SendNameBuffer
        mov ds,si
        mov si,offset SendNameBuffer
        call GetFileName

        mov ah,2
        mov bh,0
        mov dh,2
        mov dl,0
        int 10h

        mov ah,9
        mov dx,seg OptionMessage1
        mov ds,dx
        mov dx,offset OptionMessage1
        int 21h

        mov ah,2
        mov bh,0
        mov dh,3
        mov dl,0
        int 10h

        mov ah,9
        mov dx,seg OptionMessage2
        mov ds,dx
        mov dx,offset OptionMessage2
        int 21h

        mov ah,2
        mov bh,0
        mov dh,4
        mov dl,0
        int 10h

        mov ah,9
        mov dx,seg EnterChoiceMessage
        mov ds,dx
        mov dx,offset EnterChoiceMessage
        int 21h
GetChoiceLoop:
        
        xor ah,ah
        int 16h

        cmp al,'1'
        je PathToReceiveLoop

        cmp al,'2'
        je Path2ToSendLoop
        
        jmp GetChoiceLoop

PathtoReceiveLoop:
        call SetVideoMode
        call InitializeCommPort
        jmp ReceiveLoop
Path2ToSendloop:
        call SetVideoMode
        call InitializeCommPort

SendLoop:
        cmp [ConnectionStartedFlag],1
        jnz StartConnection

         mov ah,1                           ; is there any character in the
         int 16h                            ; KB buffer?
         jz nokeypressed                        

                                            ; YES:
         mov ah,0
         int 16h                             ; get the character in al

        mov bl,CursorXMaster
        mov cl,CursorYMaster
        call AdjustViewPort
        mov bl,[CurrentX]
        mov cl,[CurrentY]
        mov CursorXMaster,bl
        mov CursorYMaster,cl



         cmp al,ESCAPE
         jz SendESC

         cmp ah,3bh
         jz StartSending

        call SendCharPacket                     ; send a char packet
                                                ; with the char in al
        jmp ReceiveLoop
exit1:
        jmp exit
StartConnection:
        call SendStartOfConnectionPacket 
        mov [ConnectionStartedFlag],1
        jmp ReceiveLoop

nokeypressed:
        cmp [EOFFlag],1
        jz SendFileEnd

        cmp [FileBeingTransfered],1
        jz PathToSendFilePacket

        call SendDummyPacket
        jmp ReceiveLoop

PathToSendFilePacket:
        jmp SendFilePacket


StartSending:
        call SendFileInitiationPacket
        mov [FilebeingTransfered],1
        jmp ReceiveLoop

SendFileEnd:
        call SendEndFilePacket
        mov [FilebeingTransfered],0
        jmp ReceiveLoop

SendFilePacket:
        call SendFileDataPacket
        jmp Receiveloop
SendESC:
         call SendESCPacket
         

ReceiveLoop:                                ; NO:
         mov dx,com2+LSR
         in al,dx
         and al,1
         jz ReceiveLoop                         ; if nothing received goto mainloop

         mov dx,com2+RDR                     ; Get the packet identification
         in al,dx                            ; byte

         cmp al,CHARPACKET                   ; check the type of the packet
         jz Character                        ; and handle it ...

         cmp al,FILEINITIATIONPACKET
         jz InitiateFile

         cmp al,FILEDATAPACKET
         jz FileData

         cmp al,FILEENDPACKET
         jz EndFile

         cmp al,DUMMYPACKET
         jz PathToSendLoop

         cmp al,ESCPACKET
         jz ESCPacketReceive

         cmp al,STARTOFCONNECTIONPACKET
         jz StartOFconnectionReceive

         mov [ErrorCode],UNKNOWNPACKET
         call DisplayErrorMessage
         jmp Exit

Character:
         call ReceiveCharPacket
PathToSendLoop:
         jmp SendLoop

InitiateFile:
         call ReceiveFileInitiationPacket
         jmp SendLoop

FileData:
         call ReceiveFileDataPacket
         jmp SendLoop

StartOfConnectionReceive:
        call ReceiveStartOfConnectionPacket 
        jmp SendLoop

EndFile:
         call ReceiveEndFilePacket
         jmp SendLoop

ESCPacketReceive:
         Call ReceiveESCPacket
         
exit:
         mov ax,4c00h
         int 21h

CODE ENDS

END Start
